
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Welcome to pyNumericalTrials’s documentation! &#8212; pyNumericalTrials 0.1.0 documentation</title>
    <link rel="stylesheet" href="_static/alabaster.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script src="_static/language_data.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Module trialManager" href="trialManager.html" />
   
  <link rel="stylesheet" href="_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <div class="section" id="welcome-to-pynumericaltrials-s-documentation">
<h1>Welcome to pyNumericalTrials’s documentation!<a class="headerlink" href="#welcome-to-pynumericaltrials-s-documentation" title="Permalink to this headline">¶</a></h1>
<p>This library was created to provide automation tools to manage the production, analysis and reproduction of results for numerical experiments.
To do this, the library works with the following assumptions and definitions:</p>
<blockquote>
<div><ol class="arabic simple">
<li><p>There is a python script that defines a numerical <em>experiment</em></p></li>
<li><p>The experiment script takes a set of <em>arguments</em> defined via the ArgParse library.</p></li>
<li><p>Each time the experiment script is run a <em>trial</em> of the experiment is preformed.</p></li>
<li><p>The outcome (data produced) of a trial depends only on the arguments provided (and perhaps a system dependent random sampler).</p></li>
</ol>
</div></blockquote>
<p>It is recommended to avoid making a change to the experiment scripts that would prevent the repetition of a previous trial.
If such a change is need, we suggest you define a new experiment script.</p>
<p>Under these assumptions, the library provides tools that automate tracking the arguments run for each trial, and saving the results of such a trial in an identifiable location.</p>
<p>Here is a quick example that makes use of <a class="reference internal" href="trialManager.html#module-pyNumericalTrials.trialManager" title="pyNumericalTrials.trialManager"><code class="xref py py-mod docutils literal notranslate"><span class="pre">pyNumericalTrials.trialManager</span></code></a>. Suppose you have some script with a few arguments:</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">argparse</span>

<span class="n">parser</span> <span class="o">=</span> <span class="n">argparse</span><span class="o">.</span><span class="n">ArgumentParser</span><span class="p">(</span><span class="n">description</span><span class="o">=</span><span class="s1">&#39;Test Spin Boson Evolution Code&#39;</span><span class="p">)</span>
<span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s1">&#39;--nBosons&#39;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">int</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="mi">3</span> <span class="p">,</span><span class="n">help</span><span class="o">=</span><span class="s1">&#39;number of bosons&#39;</span><span class="p">)</span>
<span class="n">parser</span><span class="o">.</span><span class="n">add_argument</span><span class="p">(</span><span class="s1">&#39;--alpha&#39;</span><span class="p">,</span> <span class="nb">type</span><span class="o">=</span><span class="nb">float</span><span class="p">,</span> <span class="n">default</span><span class="o">=</span><span class="mi">1</span> <span class="p">,</span><span class="n">help</span><span class="o">=</span><span class="s1">&#39;coupling paramter&#39;</span><span class="p">)</span>

<span class="k">def</span> <span class="nf">compute_point</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">dataLoc</span><span class="p">):</span>
     <span class="c1"># do some computation based on args</span>
     <span class="n">result</span> <span class="o">=</span> <span class="n">args</span><span class="o">.</span><span class="n">nBosons</span> <span class="o">+</span> <span class="n">args</span><span class="o">.</span><span class="n">alpha</span>
     <span class="c1"># save data</span>
     <span class="n">np</span><span class="o">.</span><span class="n">savetxt</span><span class="p">(</span><span class="n">dataLoc</span><span class="o">+</span><span class="s2">&quot;results.txt&quot;</span><span class="p">,</span> <span class="n">result</span><span class="p">)</span>

<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">args</span> <span class="o">=</span> <span class="n">parser</span><span class="o">.</span><span class="n">parse_args</span><span class="p">()</span>
    <span class="n">compute_point</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="s2">&quot;/somelocation/&quot;</span><span class="p">)</span>
</pre></div>
</div>
<p>You can then add the simple modification to track the parameters of the script in a sql Database</p>
<div class="highlight-python notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">pyNumericalTrials.trialManager</span> <span class="k">as</span> <span class="nn">tm</span>

<span class="n">experiementName</span> <span class="o">=</span> <span class="s2">&quot;01a_test&quot;</span>
<span class="n">databaseDir</span> <span class="o">=</span> <span class="s2">&quot;./&quot;</span>
<span class="n">trialInitser</span> <span class="o">=</span> <span class="n">tm</span><span class="o">.</span><span class="n">trialManager</span><span class="p">(</span><span class="n">parser</span><span class="p">,</span> <span class="n">experiementName</span><span class="p">,</span> <span class="s2">&quot;discription&quot;</span><span class="p">,</span> <span class="n">databaseDir</span><span class="p">,</span> <span class="n">addMaster</span> <span class="o">=</span> <span class="kc">True</span><span class="p">)</span>

<span class="k">if</span> <span class="vm">__name__</span> <span class="o">==</span> <span class="s1">&#39;__main__&#39;</span><span class="p">:</span>
    <span class="n">dataLoc</span><span class="p">,</span> <span class="n">args</span> <span class="o">=</span> <span class="n">trialInitser</span><span class="o">.</span><span class="n">parseNadd</span><span class="p">()</span>

    <span class="n">compute_point</span><span class="p">(</span><span class="n">args</span><span class="p">,</span> <span class="n">dataLoc</span><span class="p">)</span>

    <span class="n">trialInitser</span><span class="o">.</span><span class="n">finalize</span><span class="p">()</span>
</pre></div>
</div>
<p>In the database directory, a file called an expieremnts.db is created (if it does not exist) which contains a sqlite database.
This file can be read with a sqlite database viewer (see <a class="reference external" href="http://sqlitebrowser.org">http://sqlitebrowser.org</a> or vscode’s sqlite addon), and contains a master table and a table for each experiment script called with a different “experiementName”.
The master table lists every trial preformed, giving its experiment (experiementName), date, whether it completed or not, and possibly a description.
The experiment tables (with name experiementName) have for columns: each parameter defined by the argParse parser, the time taken for computation and a description column.
trialInitser will also create a directory for each experiment, and in that directory it will create a directory for each trial that the result of the experiment can store data in.
The location of that directory is given by dataLoc returned by trialInitser.parseNadd().
This allows the script to save data in a location unique to the time it was called.</p>
<p>The other purpose of this library is to manage execution of multiple trials with different parameters, random sampleing, parallelization, and data management.  These features are provided by <code class="xref py py-mod docutils literal notranslate"><span class="pre">pyNumericalTrials.executionManager</span></code> and <code class="xref py py-mod docutils literal notranslate"><span class="pre">pyNumericalTrials.readNplot</span></code>. A few examples are:</p>
<blockquote>
<div><ol class="arabic simple">
<li><p>Saving (<a class="reference internal" href="executionManager.html#pyNumericalTrials.executionManager.executionManager.averageNSave" title="pyNumericalTrials.executionManager.executionManager.averageNSave"><code class="xref py py-func docutils literal notranslate"><span class="pre">averageNSave</span></code></a>) and reading(<a class="reference internal" href="readNplot.html#pyNumericalTrials.readNplot.get_results" title="pyNumericalTrials.readNplot.get_results"><code class="xref py py-func docutils literal notranslate"><span class="pre">get_results</span></code></a>) data into or from an sql database.</p></li>
<li><p>Sweeping a parameter of the experiment script. <code class="xref py py-mod docutils literal notranslate"><span class="pre">pyNumericalTrials.executionManager</span></code></p></li>
<li><p>Averaging over random dictionaries.   (<a class="reference internal" href="executionManager.html#pyNumericalTrials.executionManager.executionManager.averageNSave" title="pyNumericalTrials.executionManager.executionManager.averageNSave"><code class="xref py py-func docutils literal notranslate"><span class="pre">averageNSave</span></code></a>)</p></li>
<li><p>Automate parallelization of 2. and 3. <a class="reference internal" href="executionManager.html#pyNumericalTrials.executionManager.executionManager" title="pyNumericalTrials.executionManager.executionManager"><code class="xref py py-class docutils literal notranslate"><span class="pre">executionManager</span></code></a></p></li>
</ol>
</div></blockquote>
<div class="toctree-wrapper compound">
<ul>
<li class="toctree-l1"><a class="reference internal" href="trialManager.html">Module trialManager</a><ul>
<li class="toctree-l2"><a class="reference internal" href="trialManager.html#structure-of-expeirments-database">Structure of Expeirments Database</a></li>
<li class="toctree-l2"><a class="reference internal" href="trialManager.html#module-pyNumericalTrials.trialManager">Module members</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="executionManager.html">Module executionManager</a><ul>
<li class="toctree-l2"><a class="reference internal" href="executionManager.html#managing-execution">Managing Execution</a></li>
<li class="toctree-l2"><a class="reference internal" href="executionManager.html#saving-and-averaging-data">Saving and Averaging Data</a></li>
<li class="toctree-l2"><a class="reference internal" href="executionManager.html#executionmanager-class">executionManager Class</a></li>
<li class="toctree-l2"><a class="reference internal" href="executionManager.html#dictionary-and-averaging-tools">Dictionary and Averaging Tools</a></li>
<li class="toctree-l2"><a class="reference internal" href="executionManager.html#internals">Internals</a></li>
</ul>
</li>
<li class="toctree-l1"><a class="reference internal" href="readNplot.html">Module readNplot</a><ul>
<li class="toctree-l2"><a class="reference internal" href="readNplot.html#reading-data">Reading data</a></li>
<li class="toctree-l2"><a class="reference internal" href="readNplot.html#plotting">Plotting</a></li>
</ul>
</li>
</ul>
</div>
</div>
<div class="section" id="indices-and-tables">
<h1>Indices and tables<a class="headerlink" href="#indices-and-tables" title="Permalink to this headline">¶</a></h1>
<ul class="simple">
<li><p><a class="reference internal" href="genindex.html"><span class="std std-ref">Index</span></a></p></li>
<li><p><a class="reference internal" href="py-modindex.html"><span class="std std-ref">Module Index</span></a></p></li>
<li><p><a class="reference internal" href="search.html"><span class="std std-ref">Search Page</span></a></p></li>
</ul>
</div>


          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="#">pyNumericalTrials</a></h1>








<h3>Navigation</h3>
<ul>
<li class="toctree-l1"><a class="reference internal" href="trialManager.html">Module trialManager</a></li>
<li class="toctree-l1"><a class="reference internal" href="executionManager.html">Module executionManager</a></li>
<li class="toctree-l1"><a class="reference internal" href="readNplot.html">Module readNplot</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="#">Documentation overview</a><ul>
      <li>Next: <a href="trialManager.html" title="next chapter">Module trialManager</a></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2021, Shane P. Kelly.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 3.2.1</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.12</a>
      
      |
      <a href="_sources/index.rst.txt"
          rel="nofollow">Page source</a>
    </div>

    

    
  </body>
</html>